From 12468aea0aca6b8bfc279c338d7a1de268116d96 Mon Sep 17 00:00:00 2001
From: Jiajin Cui <cuijiajin@uniontech.com>
Date: Fri, 17 Jul 2020 17:34:09 +0800
Subject: [PATCH] gdiplus: Fix crash if failed to create bitmap.

Signed-off-by: Jiajin Cui <cuijiajin@uniontech.com>
---
 dlls/gdiplus/graphics.c | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

diff --git a/dlls/gdiplus/graphics.c b/dlls/gdiplus/graphics.c
index 6c50d2d56c..b15ce8103b 100644
--- a/dlls/gdiplus/graphics.c
+++ b/dlls/gdiplus/graphics.c
@@ -459,6 +459,9 @@ static GpStatus alpha_blend_hdc_pixels(GpGraphics *graphics, INT dst_x, INT dst_
     hbitmap = CreateDIBSection(hdc, (BITMAPINFO*)&bih, DIB_RGB_COLORS,
         (void**)&temp_bits, NULL, 0);
 
+    if(!hbitmap || !temp_bits)
+        goto done;
+
     if ((GetDeviceCaps(graphics->hdc, TECHNOLOGY) == DT_RASPRINTER &&
          GetDeviceCaps(graphics->hdc, SHADEBLENDCAPS) == SB_NONE) ||
             fmt & PixelFormatPAlpha)
@@ -470,9 +473,12 @@ static GpStatus alpha_blend_hdc_pixels(GpGraphics *graphics, INT dst_x, INT dst_
     SelectObject(hdc, hbitmap);
     gdi_alpha_blend(graphics, dst_x, dst_y, src_width, src_height,
                     hdc, 0, 0, src_width, src_height);
-    DeleteDC(hdc);
+
     DeleteObject(hbitmap);
 
+done:
+    DeleteDC(hdc);
+
     return Ok;
 }
 
-- 
2.20.1

